<?php

include("_@configs.php");

header("Access-Control-Allow-Origin: *");

$detail = array(); $streamURL = ""; $refererURL = ""; $originURL = "";
$id = ""; $cid = ""; $key = ""; $chunks = ""; $segment = ""; $vtoken = "";
if(isset($_REQUEST['id'])) { $id = trim($_REQUEST['id']); }
if(isset($_REQUEST['cid'])) { $cid = trim($_REQUEST['cid']); }
if(isset($_REQUEST['key'])) { $key = trim($_REQUEST['key']); }
if(isset($_REQUEST['chunks'])) { $chunks = trim($_REQUEST['chunks']); }
if(isset($_REQUEST['segment'])) { $segment = trim($_REQUEST['segment']); }
if(isset($_REQUEST['vtoken'])) { $vtoken = trim($_REQUEST['vtoken']); }

if(!empty($id)) { $detail = getChannelDetail($id); }
if(!empty($cid)) { $detail = getChannelDetail($cid); }
if(!empty($detail)) {
    $streamURL = $detail['u'];
    $refererURL = $detail['r'];
    $originURL = rtrim($detail['r'], "/");
    $strmHeader = array("Referer: ".$refererURL, "Origin: ".$originURL, "User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/127.0.0.0 Safari/537.36");
} else {
    $strmHeader = array("User-Agent: Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/127.0.0.0 Safari/537.36");
}

if(stripos($_SERVER['REQUEST_URI'], ".php?") !== false){ $HLS_EXT = $KEY_EXT = $TS_EXT = ".php"; } else { $HLS_EXT = ".m3u8"; $KEY_EXT = ".key"; $TS_EXT = ".ts"; }
$CSTRMFILE = str_replace(".php", "", basename($_SERVER['SCRIPT_NAME']));

//================================================//

if(!empty($id))
{
    if(!filter_var($streamURL, FILTER_VALIDATE_URL)) {
        header("X-Kafka-Error: Channel Playback Data Unavailable");
        http_response_code(404);
        exit();
    }
    $fetch = getRequest($streamURL, $strmHeader);
    $return = $fetch['data'];
    if(stripos($return, "#EXTM3U") !== false)
    {
        updateChannelStreamURL($id, $fetch['url']);
        $tine = "";
        $line = explode("\n", $return);
        foreach($line as $vine)
        {
            if(stripos($vine, 'URI="') !== false)
            {
                $orgURL = getXPURI($vine);
                $iBaseURL = getRelBase($fetch['url']);
                if(stripos($iBaseURL, "http://") !== false || stripos($iBaseURL, "https://") !== false){ $iBaseURL = ""; }
                $norgURL = $CSTRMFILE.$HLS_EXT."?cid=".$id."&chunks=".enc_dec('encrypt', $iBaseURL.$orgURL)."&vtoken=".$vtoken;
                $tine .= str_replace($orgURL, $norgURL, $vine)."\n";
            }
            elseif(stripos($vine, 'URI="') === false && stripos($vine, ".m3u8") !== false)
            {
                $iBaseURL = getRelBase($fetch['url']);
                $tine .= $CSTRMFILE.$HLS_EXT."?cid=".$id."&chunks=".enc_dec('encrypt', $iBaseURL.$vine)."&vtoken=".$vtoken."\n";
            }
            else
            {
                $tine .= $vine."\n";
            }
        }
        header("Content-Type: ".$fetch['content_type']);
        print(trim($tine));
        exit();
    }
    header("X-Kafka-Error: Channel Playback Data Unavailable");
    http_response_code(502);
    exit();
}
elseif(!empty($chunks))
{
    $playURL = enc_dec('decrypt', $chunks);
    if(!filter_var($playURL, FILTER_VALIDATE_URL)) {
        header("X-Kafka-Error: Channel Playback Data Unavailable");
        http_response_code(404);
        exit();
    }
    $fetch = getRequest($playURL, $strmHeader);
    $return = $fetch['data'];
    if(stripos($return, "#EXTM3U") !== false)
    {
        $tine = "";
        $line = explode("\n", $return);
        foreach($line as $vine)
        {
            if(stripos($vine, 'URI="') !== false)
            {
                $orgURL = getXPURI($vine);
                $iBaseURL = getRelBase($fetch['url']);
                if(stripos($iBaseURL, "http://") !== false || stripos($iBaseURL, "https://") !== false){ $iBaseURL = ""; }
                $norgURL = $CSTRMFILE.$KEY_EXT."?cid=".$cid."&key=".enc_dec('encrypt', $iBaseURL.$orgURL)."&vtoken=".$vtoken;
                $tine .= str_replace($orgURL, $norgURL, $vine)."\n";
            }
            elseif(stripos($vine, 'URI="') === false && stripos($vine, ".ts") !== false)
            {
                $iBaseURL = getRelBase($fetch['url']);
                $tine .= $CSTRMFILE.$TS_EXT."?cid=".$cid."&segment=".enc_dec('encrypt', $iBaseURL.$vine)."&vtoken=".$vtoken."\n";
            }
            else
            {
                $tine .= $vine."\n";
            }
        }
        header("Content-Type: ".$fetch['content_type']);
        print(trim($tine));
        exit();
    }
    header("X-Kafka-Error: Channel Playback Data Unavailable");
    http_response_code(502);
    exit();
}
elseif(!empty($key))
{
    $playURL = enc_dec('decrypt', $key);
    if(!filter_var($playURL, FILTER_VALIDATE_URL)) {
        header("X-Kafka-Error: Channel Playback Data Unavailable");
        http_response_code(404);
        exit();
    }
    $playURL = str_replace(getRootBase($playURL), "https://key.mizhls.ru", $playURL);
    $fetch = getRequest($playURL, $strmHeader);
    $return = $fetch['data'];
    if(!empty($return) && strlen($return) == 16)
    {
        header("Content-Type: ".$fetch['content_type']);
        print($return);
        exit();
    }
    header("X-Kafka-Error: Key Fetch Failed");
    http_response_code(403);
    exit();
}
elseif(!empty($segment))
{
    $playURL = enc_dec('decrypt', $segment);
    if(!filter_var($playURL, FILTER_VALIDATE_URL)) {
        header("X-Kafka-Error: Channel Playback Data Unavailable");
        http_response_code(404);
        exit();
    }
    $fetch = getRequest($playURL, $strmHeader);
    $return = $fetch['data'];
    if($fetch['code'] == 200 || $fetch['code'] == 206 && !empty($return))
    {
        header("Content-Type: ".$fetch['content_type']);
        print($return);
        exit();
    }
    header("X-Kafka-Error: Key Fetch Failed");
    http_response_code(403);
    exit();
}
else
{
    http_response_code(400); exit();
}

?>